-- arch-tag: 7388c0f8-57ed-4cc0-9c34-bb946e5596a2

module ArrayLib where


import Data.Array.IArray
import Data.Array.Unboxed
import Data.Array.Base

subArray :: (Integral i, IArray a e, Ix i, IArray a e) => a i e -> i -> i -> i -> a i e
subArray array from to from' =
    listArray 
	(from', from' + fromIntegral (rangeSize (from, to)) - 1)
	[ array ! i | i <- range (from, to) ]

findInArray e arr pos maxPos 
    | pos > maxPos	= Nothing
    | (arr ! pos) == e  = Just pos
    | otherwise		= findInArray e arr (pos+1) maxPos


restrictUArray :: i -> i -> UArray i e -> UArray i e
restrictUArray ns ne (UArray s e ba) = UArray ns ne ba 
