module DocLike(DocLike(..), empty, (<>), hcat, tshow) where

-- arch-tag: a88f19fb-e18d-475f-b6d1-8da78676261a

import Data.Monoid

--infixr 5 </>,<//>,<$>,<$$>
infixr 6 <>,<+>

empty :: Monoid a => a
empty = mempty
(<>) :: Monoid a => a -> a -> a
(<>) = mappend
hcat :: Monoid a => [a] -> a
hcat = mconcat

class Monoid a => DocLike a where
    (<+>) :: a -> a -> a
    hsep :: [a] -> a
    text :: String -> a
    char :: Char -> a
    parens :: a -> a

    hsep [] = empty
    hsep xs = foldr1 (<+>) xs
    char x = text [x]
    text x = mconcat (map char x)
    x <+> y = x <> char ' ' <> y 
    parens x = char '(' <> x <> char ')'

------------------------
-- Basic building blocks
------------------------

tshow :: (Show a,DocLike b) => a -> b
tshow x = text (show x)


------------------
-- String instance
------------------
instance DocLike String where
    a <+> b = a ++ " " ++ b
    parens a = "(" <> a <> ")"
    text x = x

--------
-- simple instances to allow distribution of an environment 
--------
--instance Monoid a => Monoid (b -> a) where
--    mempty = \_ -> mempty 
--    mappend x y = \a -> mappend (x a) (y a)
--    mconcat xs = \a -> mconcat (map ($ a) xs)
--
--instance (DocLike a, Monoid (b -> a)) => DocLike (b -> a) where
--    parens x = \a -> parens (x a)
--    (<+>) x y = \a -> x a <+> y a
    
